CUDNN Frontend API 8.3.0

Public Types | Public Member Functions | Public Attributes | Private Types | Private Attributes | Friends | List of all members
nlohmann::detail::iter_impl< BasicJsonType > Class Template Reference

a template for a bidirectional iterator for the basic_json class This class implements a both iterators (iterator and const_iterator) for the basic_json class. More...

`#include <json.hpp>`

Collaboration diagram for nlohmann::detail::iter_impl< BasicJsonType >:

## Public Types
using | iterator_category = std::bidirectional_iterator_tag
using | value_type = typename BasicJsonType::value_type
| the type of the values when the iterator is dereferenced More...
using | difference_type = typename BasicJsonType::difference_type
| a type to represent differences between iterators More...
using | pointer = typename std::conditional< std::is_const< BasicJsonType >::value, typename BasicJsonType::const_pointer, typename BasicJsonType::pointer >::type
| defines a pointer to the type iterated over (value_type) More...
using | reference = typename std::conditional< std::is_const< BasicJsonType >::value, typename BasicJsonType::const_reference, typename BasicJsonType::reference >::type
| defines a reference to the type iterated over (value_type) More...

## Public Member Functions
| iter_impl ()=default
| ~iter_impl ()=default
| iter_impl (iter_impl &&) noexcept=default
iter_impl & | operator= (iter_impl &&) noexcept=default
| iter_impl (pointer object) noexcept
| constructor for a given JSON instance More...
| iter_impl (const iter_impl< const BasicJsonType > &other) noexcept
| const copy constructor More...
iter_impl & | operator= (const iter_impl< const BasicJsonType > &other) noexcept
| converting assignment More...
| iter_impl (const iter_impl< typename std::remove_const< BasicJsonType >::type > &other) noexcept
| converting constructor More...
iter_impl & | operator= (const iter_impl< typename std::remove_const< BasicJsonType >::type > &other) noexcept
| converting assignment More...
| switch (m_object->m_type)
void | set_end () noexcept
| set the iterator past the last value More...
reference | operator* () const
| return a reference to the value pointed to by the iterator More...
pointer | operator-> () const
| dereference the iterator More...
iter_impl const | operator++ (int)
| post-increment (it++) More...
iter_impl & | operator++ ()
| pre-increment (++it) More...
iter_impl const | operator-- (int)
| post-decrement (it–) More...
iter_impl & | operator-- ()
| pre-decrement (–it) More...
template<typename IterImpl , detail::enable_if_t<(std::is_same< IterImpl, iter_impl >::value||std::is_same< IterImpl, other_iter_impl >::value), std::nullptr_t > = nullptr>
bool | operator== (const IterImpl &other) const
| comparison: equal More...
template<typename IterImpl , detail::enable_if_t<(std::is_same< IterImpl, iter_impl >::value||std::is_same< IterImpl, other_iter_impl >::value), std::nullptr_t > = nullptr>
bool | operator!= (const IterImpl &other) const
| comparison: not equal More...
bool | operator< (const iter_impl &other) const
| comparison: smaller More...
bool | operator<= (const iter_impl &other) const
| comparison: less than or equal More...
bool | operator> (const iter_impl &other) const
| comparison: greater than More...
bool | operator>= (const iter_impl &other) const
| comparison: greater than or equal More...
iter_impl & | operator+= (difference_type i)
| add to iterator More...
iter_impl & | operator-= (difference_type i)
| subtract from iterator More...
iter_impl | operator+ (difference_type i) const
| add to iterator More...
iter_impl | operator- (difference_type i) const
| subtract from iterator More...
difference_type | operator- (const iter_impl &other) const
| return difference More...
reference | operator[] (difference_type n) const
| access to successor More...
const object_t::key_type & | key () const
| return the key of an object iterator More...
reference | value () const
| return the value of an iterator More...

## Public Attributes
JSON_PRIVATE_UNLESS_TESTED | __pad0__: void set_begin() noexcept { JSON_ASSERT(m_object != nullptr)
JSON_PRIVATE_UNLESS_TESTED | __pad1__: pointer m_object = nullptr
internal_iterator< typename std::remove_const< BasicJsonType >::type > | m_it {}
| the actual iterator of the associated instance More...

## Private Types
using | other_iter_impl = iter_impl< typename std::conditional< std::is_const< BasicJsonType >::value, typename std::remove_const< BasicJsonType >::type, const BasicJsonType >::type >
| the iterator with BasicJsonType of different const-ness More...
using | object_t = typename BasicJsonType::object_t
using | array_t = typename BasicJsonType::array_t

## Private Attributes
friend | other_iter_impl
| allow basic_json to access private members More...
friend | BasicJsonType
friend | iteration_proxy< iter_impl >
friend | iteration_proxy_value< iter_impl >

## Friends
iter_impl | operator+ (difference_type i, const iter_impl &it)
| addition of distance and iterator More...

## Detailed Description

### template<typename BasicJsonType>
class nlohmann::detail::iter_impl< BasicJsonType >

a template for a bidirectional iterator for the basic_json class This class implements a both iterators (iterator and const_iterator) for the basic_json class.

Note
  An iterator is called initialized when a pointer to a JSON value has been set (e.g., by a constructor or a copy assignment). If the iterator is default-constructed, it is uninitialized and most methods are undefined. The library uses assertions to detect calls on uninitialized iterators.** The class satisfies the following concept requirements:
  - BidirectionalIterator: The iterator that can be moved can be moved in both directions (i.e. incremented and decremented).

Since
  version 1.0.0, simplified in version 2.0.9, change to bidirectional iterators in version 3.0.0 (see https://github.com/nlohmann/json/issues/593)

Definition at line 11348 of file json.hpp.

## Member Typedef Documentation

## ◆ array_t

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::array_t = typename BasicJsonType::array_t
| private

Definition at line 11359 of file json.hpp.

## ◆ difference_type

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::difference_type = typename BasicJsonType::difference_type

a type to represent differences between iterators

Definition at line 11376 of file json.hpp.

## ◆ iterator_category

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::iterator_category = std::bidirectional_iterator_tag

The std::iterator class template (used as a base class to provide typedefs) is deprecated in C++17. The C++ Standard has never required user-defined iterators to derive from std::iterator. A user-defined iterator should provide publicly accessible typedefs named iterator_category, value_type, difference_type, pointer, and reference. Note that value_type is required to be non-const, even for constant iterators.

Definition at line 11371 of file json.hpp.

## ◆ object_t

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::object_t = typename BasicJsonType::object_t
| private

Definition at line 11358 of file json.hpp.

## ◆ other_iter_impl

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::other_iter_impl = iter_impl<typename std::conditional<std::is_const<BasicJsonType>::value, typename std::remove_const<BasicJsonType>::type, const BasicJsonType>::type>
| private

the iterator with BasicJsonType of different const-ness

Definition at line 11351 of file json.hpp.

## ◆ pointer

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::pointer = typename std::conditional<std::is_const<BasicJsonType>::value, typename BasicJsonType::const_pointer, typename BasicJsonType::pointer>::type

defines a pointer to the type iterated over (value_type)

Definition at line 11380 of file json.hpp.

## ◆ reference

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::reference = typename std::conditional<std::is_const<BasicJsonType>::value, typename BasicJsonType::const_reference, typename BasicJsonType::reference>::type

defines a reference to the type iterated over (value_type)

Definition at line 11385 of file json.hpp.

## ◆ value_type

template<typename BasicJsonType>

using nlohmann::detail::iter_impl< BasicJsonType >::value_type = typename BasicJsonType::value_type

the type of the values when the iterator is dereferenced

Definition at line 11374 of file json.hpp.

## Constructor & Destructor Documentation

## ◆ iter_impl() [1/5]

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::iter_impl | ( |  | ) |
| default

## ◆ ~iter_impl()

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::~iter_impl | ( |  | ) |
| default

## ◆ iter_impl() [2/5]

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::iter_impl | ( | iter_impl< BasicJsonType > && |  | ) |
| defaultnoexcept

## ◆ iter_impl() [3/5]

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::iter_impl | ( | pointer | object | ) |
| inlineexplicitnoexcept

constructor for a given JSON instance

Parameters

  [in] | object | pointer to a JSON object for this iterator

Precondition
  object != nullptr

Postcondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11398 of file json.hpp.

References nlohmann::detail::array, JSON_ASSERT, and nlohmann::detail::object.

## ◆ iter_impl() [4/5]

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::iter_impl | ( | const iter_impl< const BasicJsonType > & | other | ) |
| inlinenoexcept

const copy constructor

Note
  The conventional copy constructor and copy assignment are implicitly defined. Combined with the following converting constructor and assignment, they support: (1) copy from iterator to iterator, (2) copy from const iterator to const iterator, and (3) conversion from iterator to const iterator. However conversion from const iterator to iterator is not defined.

Parameters

  [in] | other | const iterator to copy from

Note
  This copy constructor had to be defined explicitly to circumvent a bug occurring on msvc v19.0 compiler (VS 2015) debug build. For more information refer to: https://github.com/nlohmann/json/issues/1608

Definition at line 11440 of file json.hpp.

## ◆ iter_impl() [5/5]

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::iter_impl | ( | const iter_impl< typename std::remove_const< BasicJsonType >::type > & | other | ) |
| inlinenoexcept

converting constructor

Parameters

  [in] | other | non-const iterator to copy from

Note
  It is not checked whether other is initialized.

Definition at line 11465 of file json.hpp.

## Member Function Documentation

## ◆ key()

template<typename BasicJsonType>

const object_t::key_type& nlohmann::detail::iter_impl< BasicJsonType >::key | ( |  | ) | const
| inline

return the key of an object iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11927 of file json.hpp.

References nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_LIKELY, and JSON_THROW.

## ◆ operator!=()

template<typename BasicJsonType>
template<typename IterImpl , detail::enable_if_t<(std::is_same< IterImpl, iter_impl >::value||std::is_same< IterImpl, other_iter_impl >::value), std::nullptr_t > = nullptr>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator!= | ( | const IterImpl & | other | ) | const
| inline

comparison: not equal

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11741 of file json.hpp.

## ◆ operator*()

template<typename BasicJsonType>

reference nlohmann::detail::iter_impl< BasicJsonType >::operator* | ( |  | ) | const
| inline

return a reference to the value pointed to by the iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11555 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_LIKELY, JSON_THROW, nlohmann::detail::null, and nlohmann::detail::object.

## ◆ operator+()

template<typename BasicJsonType>

iter_impl nlohmann::detail::iter_impl< BasicJsonType >::operator+ | ( | difference_type | i | ) | const
| inline

add to iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11842 of file json.hpp.

## ◆ operator++() [1/2]

template<typename BasicJsonType>

iter_impl const nlohmann::detail::iter_impl< BasicJsonType >::operator++ | ( | int |  | ) |
| inline

post-increment (it++)

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11626 of file json.hpp.

## ◆ operator++() [2/2]

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator++ | ( |  | ) |
| inline

pre-increment (++it)

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11637 of file json.hpp.

References nlohmann::detail::array, JSON_ASSERT, and nlohmann::detail::object.

## ◆ operator+=()

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator+= | ( | difference_type | i | ) |
| inline

add to iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11804 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_THROW, and nlohmann::detail::object.

## ◆ operator-() [1/2]

template<typename BasicJsonType>

iter_impl nlohmann::detail::iter_impl< BasicJsonType >::operator- | ( | difference_type | i | ) | const
| inline

subtract from iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11864 of file json.hpp.

## ◆ operator-() [2/2]

template<typename BasicJsonType>

difference_type nlohmann::detail::iter_impl< BasicJsonType >::operator- | ( | const iter_impl< BasicJsonType > & | other | ) | const
| inline

return difference

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11875 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::internal_iterator< BasicJsonType >::array_iterator, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_THROW, nlohmann::detail::iter_impl< BasicJsonType >::m_it, nlohmann::detail::object, and nlohmann::detail::internal_iterator< BasicJsonType >::primitive_iterator.

## ◆ operator--() [1/2]

template<typename BasicJsonType>

iter_impl const nlohmann::detail::iter_impl< BasicJsonType >::operator-- | ( | int |  | ) |
| inline

post-decrement (it–)

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11669 of file json.hpp.

## ◆ operator--() [2/2]

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator-- | ( |  | ) |
| inline

pre-decrement (–it)

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11680 of file json.hpp.

References nlohmann::detail::array, JSON_ASSERT, and nlohmann::detail::object.

## ◆ operator-=()

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator-= | ( | difference_type | i | ) |
| inline

subtract from iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11833 of file json.hpp.

## ◆ operator->()

template<typename BasicJsonType>

pointer nlohmann::detail::iter_impl< BasicJsonType >::operator-> | ( |  | ) | const
| inline

dereference the iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11592 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_LIKELY, JSON_THROW, and nlohmann::detail::object.

## ◆ operator<()

template<typename BasicJsonType>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator< | ( | const iter_impl< BasicJsonType > & | other | ) | const
| inline

comparison: smaller

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11750 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::internal_iterator< BasicJsonType >::array_iterator, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_UNLIKELY, JSON_THROW, nlohmann::detail::iter_impl< BasicJsonType >::m_it, nlohmann::detail::object, and nlohmann::detail::internal_iterator< BasicJsonType >::primitive_iterator.

## ◆ operator<=()

template<typename BasicJsonType>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator<= | ( | const iter_impl< BasicJsonType > & | other | ) | const
| inline

comparison: less than or equal

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11777 of file json.hpp.

## ◆ operator=() [1/3]

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator= | ( | iter_impl< BasicJsonType > && |  | ) |
| defaultnoexcept

## ◆ operator=() [2/3]

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator= | ( | const iter_impl< const BasicJsonType > & | other | ) |
| inlinenoexcept

converting assignment

Parameters

  [in] | other | const iterator to copy from

Returns
  const/non-const iterator

Note
  It is not checked whether other is initialized.

Definition at line 11450 of file json.hpp.

References nlohmann::detail::iter_impl< BasicJsonType >::m_it.

## ◆ operator=() [3/3]

template<typename BasicJsonType>

iter_impl& nlohmann::detail::iter_impl< BasicJsonType >::operator= | ( | const iter_impl< typename std::remove_const< BasicJsonType >::type > & | other | ) |
| inlinenoexcept

converting assignment

Parameters

  [in] | other | non-const iterator to copy from

Returns
  const/non-const iterator

Note
  It is not checked whether other is initialized.

Definition at line 11475 of file json.hpp.

References JSON_PRIVATE_UNLESS_TESTED, and nlohmann::detail::iter_impl< BasicJsonType >::m_it.

## ◆ operator==()

template<typename BasicJsonType>
template<typename IterImpl , detail::enable_if_t<(std::is_same< IterImpl, iter_impl >::value||std::is_same< IterImpl, other_iter_impl >::value), std::nullptr_t > = nullptr>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator== | ( | const IterImpl & | other | ) | const
| inline

comparison: equal

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11713 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_UNLIKELY, JSON_THROW, and nlohmann::detail::object.

## ◆ operator>()

template<typename BasicJsonType>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator> | ( | const iter_impl< BasicJsonType > & | other | ) | const
| inline

comparison: greater than

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11786 of file json.hpp.

## ◆ operator>=()

template<typename BasicJsonType>

bool nlohmann::detail::iter_impl< BasicJsonType >::operator>= | ( | const iter_impl< BasicJsonType > & | other | ) | const
| inline

comparison: greater than or equal

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11795 of file json.hpp.

References nlohmann::detail::operator<().

## ◆ operator[]()

template<typename BasicJsonType>

reference nlohmann::detail::iter_impl< BasicJsonType >::operator[] | ( | difference_type | n | ) | const
| inline

access to successor

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11896 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::invalid_iterator::create(), JSON_ASSERT, JSON_HEDLEY_LIKELY, JSON_THROW, nlohmann::detail::null, and nlohmann::detail::object.

## ◆ set_end()

template<typename BasicJsonType>

void nlohmann::detail::iter_impl< BasicJsonType >::set_end | ( |  | ) |
| inlinenoexcept

set the iterator past the last value

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11524 of file json.hpp.

References nlohmann::detail::array, JSON_ASSERT, and nlohmann::detail::object.

Referenced by nlohmann::basic_json< ObjectType, ArrayType, StringType, BooleanType, NumberIntegerType, NumberUnsignedType, NumberFloatType, AllocatorType, JSONSerializer, BinaryType >::cend(), and nlohmann::basic_json< ObjectType, ArrayType, StringType, BooleanType, NumberIntegerType, NumberUnsignedType, NumberFloatType, AllocatorType, JSONSerializer, BinaryType >::end().

## ◆ switch()

template<typename BasicJsonType>

nlohmann::detail::iter_impl< BasicJsonType >::switch | ( | m_object-> | m_type | ) |
| inline

Definition at line 11491 of file json.hpp.

References nlohmann::detail::array, nlohmann::detail::null, and nlohmann::detail::object.

## ◆ value()

template<typename BasicJsonType>

reference nlohmann::detail::iter_impl< BasicJsonType >::value | ( |  | ) | const
| inline

return the value of an iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11943 of file json.hpp.

References JSON_PRIVATE_UNLESS_TESTED.

## Friends And Related Function Documentation

## ◆ operator+

template<typename BasicJsonType>

iter_impl operator+ | ( | difference_type | i,
|  | const iter_impl< BasicJsonType > & | it
| ) |  |
| friend

addition of distance and iterator

Precondition
  The iterator is initialized; i.e. `m_object != nullptr`.

Definition at line 11853 of file json.hpp.

## Member Data Documentation

## ◆ __pad0__

template<typename BasicJsonType>

JSON_PRIVATE_UNLESS_TESTED nlohmann::detail::iter_impl< BasicJsonType >::__pad0__

Definition at line 11489 of file json.hpp.

## ◆ __pad1__

template<typename BasicJsonType>

JSON_PRIVATE_UNLESS_TESTED nlohmann::detail::iter_impl< BasicJsonType >::__pad1__

Definition at line 11950 of file json.hpp.

## ◆ BasicJsonType

template<typename BasicJsonType>

friend nlohmann::detail::iter_impl< BasicJsonType >::BasicJsonType
| private

Definition at line 11354 of file json.hpp.

## ◆ iteration_proxy< iter_impl >

template<typename BasicJsonType>

friend nlohmann::detail::iter_impl< BasicJsonType >::iteration_proxy< iter_impl >
| private

Definition at line 11355 of file json.hpp.

## ◆ iteration_proxy_value< iter_impl >

template<typename BasicJsonType>

friend nlohmann::detail::iter_impl< BasicJsonType >::iteration_proxy_value< iter_impl >
| private

Definition at line 11356 of file json.hpp.

## ◆ m_it

template<typename BasicJsonType>

internal_iterator<typename std::remove_const<BasicJsonType>::type> nlohmann::detail::iter_impl< BasicJsonType >::m_it {}

the actual iterator of the associated instance

Definition at line 11952 of file json.hpp.

Referenced by nlohmann::basic_json< ObjectType, ArrayType, StringType, BooleanType, NumberIntegerType, NumberUnsignedType, NumberFloatType, AllocatorType, JSONSerializer, BinaryType >::insert(), nlohmann::basic_json< ObjectType, ArrayType, StringType, BooleanType, NumberIntegerType, NumberUnsignedType, NumberFloatType, AllocatorType, JSONSerializer, BinaryType >::insert_iterator(), nlohmann::detail::iter_impl< BasicJsonType >::operator-(), nlohmann::detail::iter_impl< BasicJsonType >::operator<(), and nlohmann::detail::iter_impl< BasicJsonType >::operator=().

## ◆ other_iter_impl

template<typename BasicJsonType>

friend nlohmann::detail::iter_impl< BasicJsonType >::other_iter_impl
| private

allow basic_json to access private members

Definition at line 11353 of file json.hpp.

The documentation for this class was generated from the following file:

- json.hpp